module AwsClient
  class ElasticSearchWrapper < AwsClient::Wrapper

    def endpoint_for_domain(domain)
      domains = domains_by_reference([domain])
      status_lists = domains.domain_status_list
      raise "ElasticSearch - nothing found for domain '#{domain}'" if status_lists.first.nil?
      return status_lists.first.endpoint
    end

    def domains_by_reference(domain_names)
      return client.describe_elasticsearch_domains(:domain_names => domain_names)
    end

  end
end
