module AwsClient
  class Elb

    attr_reader :raw_data, :raw_tags

    def initialize(raw_data)
      @raw_data = raw_data
    end

    def is_for_tag?(tag_key, tag_value)
      tags.include?({ tag_key => tag_value})
    end

    def add_tags!(tag_data)
      @raw_tags = tag_data.tags
    end

    def name
      @raw_data.load_balancer_name
    end

    def dns_name
      @raw_data.dns_name
    end 

    def tags
      @tags ||= @raw_tags.collect{|raw_tag| {raw_tag.key => raw_tag.value } }
    end     

  end
end
